package facets.core.app;
import static facets.util.app.Events.*;
import facets.util.app.AppValues;
/**
Constants useful for abstract applications, especially those based on {@link AppValues}. 
 */
public interface AppConstants{
	/**
	Unicode strings for arrow "logos". 
	 */
	String ARROW_LEFT="\u25c4",ARROW_RIGHT="\u25ba",ARROW_UP="\u25b2",
		ARROW_DOWN="\u25bc";
	/**
	Title for menu target. 
	 */
	String TITLE_APP_REOPEN="Re&fresh View",
	TITLE_APP_PREFERENCES="Pre&ferences",
	TITLE_APP_ABOUT="About",
	TITLE_APP_HELP="Sho&w Help",
	TITLE_APP_CLOSE="E&xit",TITLE_NEW="New|Content",
	TITLE_FILE_NEW="New",TITLE_FILE_OPEN="Open...",
	TITLE_FILE_SAVE="Save",TITLE_FILE_SAVE_AS="Save &as...",
	TITLE_FILE_REVERT="Reload",
	TITLE_FILE_CLOSE="Close|Close File",TITLE_FILE_CLOSEALL="C&lose All",
	TITLE_WINDOW_NEW="New",TITLE_WINDOW_CLOSE="Close|Close Window";
	/**
	For inserting application title into eg rubrics. 
	 */
	String TAG_APP_TITLE="$appTitle",FIND_APP_TITLE="\\$appTitle";
	/**
	Title/rubric for use in dialogs. 
	 */
	String TITLE_OK="OK",TITLE_APPLY="Apply",TITLE_CANCEL="Cancel",
	TITLE_REVERT="Revert",TITLE_CLOSE="Close",
	TITLE_CLOSE_REQUESTED="Close Requested",
	RUBRIC_CONFIRM_CLOSE="Close " +TAG_APP_TITLE+"?",
	TITLE_NO_FILE="No valid file",
	TITLE_NO_NEW="Cannot create content",
	TITLE_FILE_OPEN_PREVIOUS="Open Previous File?";
	/**
	Key for configuration or session value. 
	 */
	String 
	NATURE_APP_ICON_INTERNAL="appIconInternal",
	NATURE_APP_ICON_SMALL="appIconSmall",
	NATURE_APP_ICON_LARGE="appIconLarge",
	NATURE_ICON_AWARE="iconAware",
	NATURE_ICON_PATH="iconPath",
	NATURE_STORE_PATH="storePath",
	NATURE_CONFIRM_CLOSE="confirmClose",
	NATURE_CONFIRM_STATE_SAVE="confirmStateSave",
	NATURE_ENSURE_FIRST_ROOT_ACTIVE="ensureFirstRootActive",
	NATURE_OPEN_EMPTY="openEmpty",
	NATURE_RUN_WATCHED="runWatched",
	NATURE_RUN_WATCHED_DEBUG="runWatchedDebug",
	NATURE_SIZE_DEFAULT="hostDefaultSize",
	NATURE_SIZE_MIN="hostMinSize",
	STATE_FILES_PATH="path",
	STATE_ODDS_BOUNDS="hostBounds";
	/**
	Type of session values node. 
	 */
	String 
	STATE_NODE_FILES="files",
	STATE_NODE_RECENT="recentFiles",
	STATE_NODE_DIALOGS="dialogs";
}
/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

