package facets.core.app;
import facets.core.superficial.SFrameTarget;
import facets.core.superficial.STarget;
import facets.core.superficial.STargeter;
import facets.core.superficial.TargetCore;
import facets.core.superficial.TargeterCore;
import facets.core.superficial.TargeterCore.TargetType;
import facets.util.ItemList;
import facets.util.Util;
/**
{@link STarget} that enables multiple selection. 
<p>{@link FrameGroup} can bundle together 
multiply-selected frames whose {@link STarget#elements()}...
 */
final public class FrameGroup extends SFrameTarget{
  private static final class FrameTargeter extends TargeterCore{
		FrameTargeter(TargetType type){
			super(type);
		}
	}
  final public class Proxy extends TargetCore{
    private Proxy(STarget[]elements){
      super(elements[0].title());
      STarget[]children=elements[0].elements();
      setElements(children.length==0?elements:newElementProxies(elements));
    }
  }
	private final SFrameTarget editable,frames[];
  /**
  Unique constructor. 
  @param editable title passed to superclass, prefixed with "Group for ";
  stored for notification by facet
  @param frames to be grouped
   */
  public FrameGroup(SFrameTarget editable,SFrameTarget[]frames){
    super("Group for "+editable.title(),frames[0]);
    this.editable=editable;
    STarget[]proxies=newElementProxies(this.frames=frames);
    setElements(proxies);
  }
  /**
	 Re-implementation to return a private {@link facets.core.app.FrameGroup.FrameTargeter}. 
	 */
	public STargeter newTargeter() {
		return true?new FrameTargeter((TargetType)framed)
			:new TargeterCore((TargetType)framed);
	}
  public void facetNotified(boolean interim){
		Object[]framed=new Object[frames.length];
		for(int i=0;i<framed.length;i++)framed[i]=frames[i].framed;
		editable.setFramedState(framed,interim);		
	}
	private STarget[]newElementProxies(STarget[]sources){
    final ItemList<STarget[]> store=new ItemList(STarget[].class);
    for(int g=0;g<sources.length;g++){
      STarget[]elements=sources[g].elements();
      for(int i=0;i<elements.length;i++){
        if(store.size()<i+1)store.addItem(new STarget[sources.length]);
       store.items()[i][g]=elements[i];
      }
    }
    STarget[][]stored=store.items();
    STarget[]proxies=new STarget[stored.length];
    for(int i=0;i<proxies.length;i++)proxies[i]=new Proxy(stored[i]);
    return proxies;
  }
}/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
