package facets.core.app;
import static facets.util.datatree.Nodes.*;
import facets.util.ItemList;
import facets.util.Objects;
import facets.util.Regex;
import facets.util.Util;
import facets.util.datatree.Nodes;
import facets.util.datatree.TypedNode;
/**
{@link TreeView} that converts {@link TypedNode}s to (typically HTML) text. 
 */
public class TextTreeView extends TreeView{
	public TextTreeView(String title){
		super(title);
	}
	final public String nodeRenderText(TypedNode node){
		return newPathNodeText(Nodes.ancestry(node),nodeText(node));
	}
	public static String nodeText(TypedNode node){
		return Objects.toLines(node.values());
	}
	protected String newPathNodeText(TypedNode[]path,String text){
		return text;
	}
	/**
	Defines a {@link PathSelection} based on an HTML path. 
	@param selectionThen identifies the HTML page containing the path
	@param path value of HREF attribute within the page 
	 */
	public static PathSelection newHtmlPathSelection(PathSelection selectionThen,String path){
		Object content=selectionThen.content(),
			membersThen[]=selectionThen.paths[0].members(content);
		TypedNode focus=(TypedNode)membersThen[membersThen.length-
				Regex.finds(path,"\\Q../\\E").length-2];
		ItemList<TypedNode>membersNow=new ItemList(TypedNode.class);
		if(path.startsWith("/")){
			path=path.substring(1);
			focus=(TypedNode)content;
		}
		if(false)Util.println("TextTreeView.newHtmlPathSelection: path="+path+" focus=",focus);
		membersNow.addItems(ancestry(focus));
		String[]downs=("../"+path).substring(("../"+path).lastIndexOf("../")+3).split("/");
		for(String down:downs){
			TypedNode found=null;
			String title=down.replaceAll("\\..*","");
			for(TypedNode child:focus.children())if(child.title().equals(title))found=child;
			if(found==null)throw new IllegalStateException("Not found "+title+" in "+focus);
			else membersNow.addItem(focus=found);
		}
		return false?selectionThen:PathSelection.newSingle(content,
				new NodePath(membersNow.items()));
	}
}/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
