package facets.core.superficial.app;
import facets.core.superficial.FacetedTarget;
import facets.core.superficial.SFrameTarget;
import facets.core.superficial.STarget;
import facets.util.Debug;
import facets.util.ItemList;
import facets.util.OffsetPath;
import facets.util.Util;
final class AreaPath extends OffsetPath{
	AreaPath(SAreaTarget root){
		super(newPathMembers(root));
	}
	private static Object[]newPathMembers(SAreaTarget root){
		FacetedTarget target=root;
		STarget child;
		ItemList<FacetedTarget>members=new ItemList(FacetedTarget.class);
		while(target instanceof SAreaTarget){
			members.addItem(target);
			child=((SAreaTarget)target).indexedTarget();
			if(!(child instanceof FacetedTarget))break;
			target=(FacetedTarget)child;
		}
		return members.items();
	}
	protected int[]newOffsets(Object[]members){			
		int[]indices=new int[members.length];
		indices[0]=0;
		for(int i=1;i<indices.length;i++)
			indices[i]=((IndexingTarget)members[i-1]).indexing().index();
		return indices;
	}
	protected Object[]newMembers(Object root,int[]indices){
    Object[]members=new Object[indices.length];
    members[0]=root;
    for(int i=1;i<members.length;i++)
    	members[i]=((IndexingTarget)members[i-1])
    		.indexableTargets()[indices[i]];
		return members;
	}
	public OffsetPath reconstructPath(Object root){
		throw new RuntimeException("Not implemented in "+Debug.info(this));
	}
	public OffsetPath procrusted(Object root,Object to){
		throw new RuntimeException("Not implemented in "+Debug.info(this));
	}
}/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
