package facets.facet;
import static facets.util.app.Events.*;
import facets.core.superficial.Notifying;
import facets.core.superficial.STarget;
import facets.core.superficial.Notifying.Impact;
import facets.facet.toolkit.KWidget;
import facets.facet.toolkit.KWrap;
import facets.facet.toolkit.Kit;
import facets.facet.toolkit.KitFacet;
import facets.util.Debug;
import facets.util.ItemList;
import facets.util.Objects;
import facets.util.StringFlags;
import facets.util.Tracer;
import facets.util.app.Events;
abstract class FacetCore extends Tracer implements KitFacet,STarget.Targeted{
	final Kit kit;
  protected STarget target;
	private KWrap[]parts;
  private ItemList<KWrap>registered=new ItemList(KWrap.class);
  FacetCore(STarget target,Kit toolkit){
  	this.kit=toolkit;
  	FacetFactory.facets++;
		if((this.target=target)==null)
			throw new IllegalArgumentException("Null target in "+Debug.info(this));
	}
  final public KWrap base(){return parts()[0];}
  final public KWrap[]items(){return parts();}
  public void targetNotify(Object msg, boolean interim){
		if(msg==null)throw new IllegalArgumentException("Null msg in "+Debug.info(this));
		String targetInfo=Debug.id(target)+" "+target.title();
    if(trace)traceEvent("Notified interim=" +interim+
    		" by " +Debug.info(msg)+
    		" in " +Debug.info(this)+" retargeted on "+targetInfo);
  }
  public void retarget(STarget target,Impact impact){
		if((this.target=target)==null)
			throw new IllegalArgumentException("Null target in "+Debug.info(this));
		else setEnablesToTarget();
	}
  public final STarget target(){
    if(target==null)throw new IllegalStateException("No target in "+Debug.info(this));
    return target;
  }
  public String title(){return target.title();}
  public String toString(){return Debug.info(this);}
  final protected void setEnables(boolean live){
		KWrap[]items=registered();if(items.length==0)return;
		if(false&&title().equals("Commit or cancel?")) {
			trace("setEnables: ",live);
			trace("setEnables: ",items);
		}
		for(int i=0;i<items.length;i++)
			if(items[i]instanceof KWidget&&items[i].facet()!=FacetFactory.BREAK)
				((KWidget)items[i]).setEnabled(live&&items[i].facet().target().isLive());
	}
  protected void setEnablesToTarget(){setEnables(target.isLive());}
  protected void deleteParts(){
		parts=null;
		registered=new ItemList(KWrap.class);
  }
  abstract KWrap lazyBase();
  abstract KWrap[]lazyParts();
  KWrap newRegisteredLabel(String title,StringFlags hints){
    KWrap label=kit.label(this,title,hints);
    registerPart(label);
    return label;
  }
  final KWrap[]parts(){
		if(parts!=null)return parts;
		KWrap base=lazyBase();
		parts=base!=null?new KWrap[]{base}:lazyParts();
		if(parts==null)throw new IllegalStateException("Null parts in "+Debug.info(this));
		for(int i=0;i<parts.length;i++)registerPart(parts[i]);
		setEnablesToTarget();
		if(false)trace(".parts: ",parts);
		return parts;		
  }
	final KWrap[]registered(){
		return(KWrap[])Objects.uniqued(KWrap.class,registered.items());
	}
  final void registerPart(KWrap part){registered.addItem(part);}
	final void registerParts(FacetCore facet){
		KWrap[]parts=facet.parts();
    for(int i=0;i<parts.length;i++)registerPart(parts[i]);
  }
	public STarget[]targets(){
		return((STarget.Targeted)base()).targets();
	}
	public KWrap[]treeWidgets(){
		return new KWrap[]{};
	}
}

/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

