package facets.facet;
import facets.core.app.MenuFacets;
import facets.core.superficial.SFacet;
import facets.core.superficial.STarget;
import facets.core.superficial.STargeter;
import facets.facet.toolkit.KWrap;
import facets.facet.toolkit.Kit;
import facets.facet.toolkit.KitFacet;
import facets.facet.toolkit.KWrap.ItemSource;
import facets.util.Debug;
import facets.util.ItemList;
import facets.util.StringFlags;
final class MenuRoot extends FacetCore implements ItemSource{
  final MenuFacets facets;
	private KWrap[]wraps;
	MenuRoot(STargeter targeter,Kit kit,MenuFacets facets){
    super(targeter.target(),kit);
    if(targeter==null)throw new IllegalArgumentException(
    		"Null targeter in "+Debug.info(this));
    this.facets=facets;
    targeter.attachFacet(this);
  }
	public String title(){
		return facets==null?super.title():facets.title();
	}
	public KWrap[]getItems(){
		if(false&&wraps!=null)return wraps;
		ItemList<KWrap>list=new ItemList(KWrap.class);
		SFacet[]facets=this.facets.getFacets();
		if(facets==null)throw new IllegalStateException(
				"No item facets in "+Debug.info(this));
		for(SFacet f:facets){
			if(f==null)continue;
			KWrap[]items=((KitFacet)f).items();
			for(KWrap item:items)if(item!=null)list.addItem(item);
		}
		wraps=list.items();
		kit.adjustMenuMnemonics(wraps);
		return wraps; 
	}
  protected KWrap[]lazyParts(){return null;}
	protected KWrap lazyBase(){
		return kit.menu(this,title(),this,StringFlags.EMPTY);
	}			
	protected void retargetedSingle(STarget target){
		wraps=null;
	}
}
/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

