package facets.facet;
import facets.core.superficial.SFacet;
import facets.core.superficial.STargeter;
import facets.facet.toolkit.KMount;
import facets.facet.toolkit.KWrap;
import facets.facet.toolkit.Kit;
import facets.facet.toolkit.KitFacet;
import facets.util.Debug;
import facets.util.ItemList;
import facets.util.StringFlags;
class RowPanel extends FacetCore{
	static boolean debug=false;
	static int panels;
	private final int hgap,vgap;
	private final StringFlags hints;
	private Object[]items;
  RowPanel(Kit toolkit,STargeter link,Object[]items,int hgap,int vgap,
  		StringFlags hints){
		super(link.target(),toolkit);
		link.attachFacet(this);
		this.hgap=hgap;
		this.vgap=vgap;
		this.items=items;
		this.hints=hints;
	}
  protected KWrap[]lazyParts(){
		return null;
	}
  protected KWrap lazyBase(){
    KMount base=kit.rowMount(this,hgap,vgap,hints);
    setItems(items!=null&&items.length>0&&items[0]!=null?items:
      new Object[]{kit.label(this,Debug.info(this),hints)},base);
    return base;
  }
  private void setItems(Object[] items){
		setItems(items,(KMount)base());
	}
  protected void setItems(Object[]items,KMount base){
		ItemList<KWrap>widgets=new ItemList(KWrap.class);
		for(int i=0;i<items.length;i++){
			if(items[i]==null||(widgets.size()==0&&items[i]==FacetFactory.BREAK))continue;
			widgets.addItem(
				items[i]==FacetFactory.BREAK?KWrap.BREAK:
				items[i]instanceof SFacet?((KitFacet)items[i]).base():
				(KWrap)items[i]
			);
		}
		base.setItems(widgets.items());
  }
  public void setFacets(SFacet[]facets){
    setItems(facets);
  }
}
/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

