package facets.facet;
import facets.core.superficial.STarget;
import facets.core.superficial.Notifying.Impact;
import facets.facet.toolkit.KButton;
import facets.facet.toolkit.KWrap;
import facets.facet.toolkit.Kit;
import facets.util.Debug;
import facets.util.StringFlags;
import facets.util.Titled;
abstract class SimpleMaster extends FacetMaster.Simple implements Titled{
	static abstract class Buttons extends SimpleMaster{
	  KButton[]buttons;
		Buttons(StringFlags hints){
			super(hints);			
		}
	  final protected int buttonIndex(){
	  	if(buttons!=null)for(int i=0;i<buttons.length;i++)
		      if(buttons[i].isSelected())return i;
	    return -1;
	  }
	  KWrap newBaseWrap(){return null;}
	  final KWrap[]newPartWraps(){
	  	if(buttons==null)throw new IllegalStateException(
	  			"Null buttons in "+Debug.info(this));
	    if(!isMenu())return buttons;
	    else return new KWrap[]{toolkit().menu(core(),title(),
	    		buttons,hints)};
	  }
	}
	final StringFlags hints;
	final boolean debug;
	protected SimpleCore core;
	SimpleMaster(StringFlags hints){
		this.hints=hints;
		debug=hints.includeFlag(FacetFactory.HINT_DEBUG);
	}
	abstract KWrap newBaseWrap();
	abstract KWrap[]newPartWraps();
	public void retargetedSingle(STarget target,Impact impact){
		retargetedMultiple(new STarget[]{target},impact);
	}
	public void retargetedMultiple(STarget[]targets,Impact impact){
		if(false)core().setEnables(targets.length==1);
	}
	final protected void targetNotify(Object msg){
		core().targetNotify(msg,false);
	}
	protected void notifyingSingle(STarget target,Object msg){
		notifyingMultiple(new STarget[]{target},msg);
	}
	void notifyingMultiple(STarget[]targets,Object msg){
		for(int i=0;i<targets.length;i++)notifyingSingle(targets[i],msg);
	}
	void setEnables(STarget target){}
  boolean forMenu(){return false;}
  boolean isMenu(){return false;}
	boolean inDialog(){return false;}
	final Kit toolkit(){
		return core().kit;
	}
  final SimpleCore core(){
		if(core==null)throw new IllegalStateException(
				"Null core in "+Debug.info(this));
		return core;
	}
	/**
	Implements interface method. 
	@return the title of the current facet target. 
	 */
	final public String title(){
		return core().target().title();
	}
	public String toString(){
  	return Debug.info(this);
  }
	final public STarget target(){
		return core().target();
	}
}/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
