package facets.facet;
import facets.core.superficial.SFacet;
import facets.core.superficial.STargeter;
import facets.facet.FacetFactory.ToolkitType;
import facets.facet.FacetMaster.Simple;
import java.util.Map;
import javax.swing.JComponent;
/**
{@link SFacet} based on {@link JComponent}s. 
<p>A {@link SwingPanelFacet} returns as {@link #components()} a
map of references to {@link JComponent}s; these references should
only be to those {@link JComponent}s that it creates and manages, and 
may be returned under multiple keys. 
<p>Where a {@link FacetFactory} is constructed with {@link ToolkitType#SWING} 
or {@link ToolkitType#SWING_SYSTEM},  
all {@link SFacet}s returned by simple facet methods will
implement {@link SwingPanelFacet}, with the following methods returning useful
implementations:
<ul><li>{@link FacetFactory#textualField(STargeter,int,String)} 
<li>{@link FacetFactory#indexingDropdownList(STargeter, String)} 
<li>{@link FacetFactory#simpleMastered(STargeter, facets.facet.FacetMaster.Simple)} 
</ul> 
<p>To obtain the components returned and keys used, query the {@link Map}
returned. 
 */
public interface SwingPanelFacet extends SFacet{
	/**
	Suitable key for use in component map. 
	 */
	String KEY_PANEL="Panel",KEY_LABEL="Label",
		KEY_LABELLED="Labelled";
	Map<String,JComponent> components();
}
/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

