package facets.facet;
import facets.core.app.MountFacet;
import facets.core.superficial.SFacet;
import facets.core.superficial.SIndexing;
import facets.core.superficial.STarget;
import facets.core.superficial.SIndexing.Coupler;
import facets.facet.toolkit.KMount;
import facets.facet.toolkit.KWrap;
import facets.facet.toolkit.Kit;
import facets.facet.toolkit.KitFacet;
import facets.util.Debug;
import facets.util.StringFlags;
class SwitchMount extends FacetCore implements MountFacet{
	private final String indexingTitle;
  private KWrap[]items;
  private SIndexing indexing;
	private Coupler external;
  SwitchMount(String indexingTitle,Kit kit){
    super(STarget.NONE,kit);
    this.indexingTitle=indexingTitle;
  }
  SIndexing swapReferences(Coupler coupler){
  	external=coupler;
    if(indexing!=null)return indexing;
    return indexing=new SIndexing(indexingTitle,new SIndexing.Coupler(){
      public boolean[]liveStates(SIndexing s){
				return external.liveStates(s);
			}
      public void indexSet(SIndexing s){
				((KMount)base()).setActiveItem((KWrap)s.indexed());
			}
      public Object[]getIndexables(){
      	if(items==null)throw new IllegalStateException("Null items in "+Debug.info(this));
      	return items;
      }
      public String[]newIndexableTitles(SIndexing i){
				return external.newIndexableTitles(i);
			}
    });
  }
	public void setFacets(SFacet...facets){
    items=new KWrap[facets.length];
	  for(int i=0;i<items.length;i++)
	    items[i]=((KitFacet)facets[i]).base();
  }
  KWrap lazyBase(){
		return kit.switchMount(this,items,new StringFlags(FacetFactory.HINT_BARE));
	}
  protected KWrap[]lazyParts(){return null;}
}/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
