package facets.facet;
import facets.core.superficial.Notifying;
import facets.core.superficial.STarget;
import facets.core.superficial.STextual;
import facets.core.superficial.Notifying.Impact;
import facets.facet.toolkit.KField;
import facets.facet.toolkit.KWrap;
import facets.util.StringFlags;
import facets.util.Util;
final class TextualField extends SimpleMaster{
  private KField field;
	private final int cols;
  TextualField(int cols,StringFlags hints){
		super(hints);
		this.cols=cols;
	}
  public void attachedToFacet(){
  	STextual t=(STextual)target();
  	field=toolkit().textField(core,cols,hints);
  	if(cols>0)field.makeEditable();
  }
	void notifyingMultiple(STarget[]targets,Object msg){
	  String text=field.text();
		for(int i=0;i<targets.length;i++) {
			STextual textual=(STextual)targets[i];
			if(true||!textual.text().equals(text))textual.setText(text);
		}
  }
	public void retargetedMultiple(STarget[]targets, Notifying.Impact impact){
		Object first=((STextual)targets[0]).text();
		boolean allSame=true;
		for(int i=0;allSame&&i<targets.length;i++)
			allSame&=((STextual)targets[i]).text().equals(first);
	  field.setIndeterminate(!allSame);		
		if(!allSame)return;
  	STextual t=(STextual)targets[0];
		field.setText(t.text());
		field.setEnabled(t.isLive());
	}
	public void respondTargetWantsFocus(){
		trace(".respondTargetWantsFocus: ");
		field.requestFocus();
	}
  public String toString(){return super.toString()+", "+field.text();}
  KWrap newBaseWrap(){return field;}
  KWrap[]newPartWraps(){return null;}
}
/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

