package facets.facet;
import facets.core.app.AppConstants;
import facets.core.app.DialogSurface;
import facets.core.app.ValueContent;
import facets.core.superficial.Notice;
import facets.core.superficial.Notifying;
import facets.core.superficial.STarget;
import facets.core.superficial.app.SContentRootTargeter;
import facets.facet.app.FacetAppSurface;
import facets.facet.app.FacetDialogContenter;
import facets.util.Util;
import facets.util.app.AppValues;
import facets.util.datatree.ValueNode;
/**
{@link FacetDialogContenter} for {@link ValueNode} content such as 
that of {@link AppValues}.
 */
public abstract class ValueDialogContenter extends FacetDialogContenter{
	protected final ValueContent content;
	protected final FacetAppSurface app;
	public ValueDialogContenter(String title,FacetAppSurface app,ValueNode master,
			ValueNode working){
		super(title,app.ff);
		this.app=app;
		content=new ValueContent(title,master,working){
			public void targetValuesUpdated(STarget target,ValueNode values,String keys){
				ValueDialogContenter.this.targetValuesUpdated(target,values,keys);
			}
		};
	}
	final public void rootRetargeted(SContentRootTargeter t){
		updateLivesOnRetargeted(content.working);
		if(false)Util.println("ValueDialogContenter.rootRetargeted: content="+content);
		STarget applyTrigger=DialogSurface.findDialogTrigger(t,AppConstants.TITLE_APPLY);
		applyTrigger.setLive(content.hasChanged());
	}
	protected abstract void targetValuesUpdated(STarget target,ValueNode values,
			String keys);
	protected abstract void updateLivesOnRetargeted(ValueNode working);
	public void applyChanges(){
		content.applyChanges();
		app.values.adjustClassValues();
		app.actions.updateLayout();
		if(app.isBuilt())app.notify(new Notice(contentFrame(),Notifying.Impact.DEFAULT));
	}
	final public void reverseChanges(){
		content.reverseChanges();
		applyChanges();
	}
}/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
