package facets.facet.app;
import static facets.facet.FacetFactory.*;
import static facets.facet.app.FacetAppValues.*;
import static facets.util.app.AppValues.*;
import static java.awt.event.KeyEvent.*;
import facets.core.app.ActionAppSurface;
import facets.core.app.AppConstants;
import facets.core.app.AppSurface;
import facets.core.app.HtmlView;
import facets.core.app.TreeView;
import facets.core.app.ActionViewerTarget.Action;
import facets.facet.AreaFacets;
import facets.facet.app.tree.TreeTargets;
import facets.util.app.AppValues;
import facets.util.app.Events;
import facets.util.datatree.DataConstants;
import facets.util.datatree.ExceptionNode;
import java.awt.event.InputEvent;
/**
Includes default decorations. 
 */
public interface FacetConstants extends AppConstants{
	int KEY_CTRL=InputEvent.CTRL_MASK<<16,KEY_SHIFT=InputEvent.SHIFT_MASK<<16;
	/**Index into {@link #DECORATION_VALUES}. */
	int DECORATION_KEY=0,DECORATION_TITLE=1,DECORATION_ICON=2,
		DECORATION_RUBRIC=3,DECORATION_KEYCODE=4;
	/** Default decorations. */
	Object[][]DECORATION_VALUES={			
		{TYPE_NATURE,"","cu_obj.gif"},
		{TYPE_STATE,"","cu_change.gif"},
		{NATURE_APP_ICON_SMALL,"","facets16.gif"},
		{NATURE_APP_ICON_LARGE,"","facets16.gif"},
		{NATURE_APP_ICON_INTERNAL,"","facets16.gif"},
		{KEY_GRAPH_BUILD,"Build &targeter graph viewer","","[Always enabled]"},
		{KEY_GRAPH_WHERE,"Show graph"},
		{KEY_GRAPH_FIND,"Find node","","Enter text to match in node title"},
		{KEY_TEXT_ALIASING,"Anti-alias graphics text"},
		{AppSurface.TITLE_EMPTY,"No Content"},
		{AreaFacets.PANE_KEY_ASK,"Al&ways ask","","Open this dialog for any unknown content"},
		{AreaFacets.PANE_KEY_DEFAULT,"Set as &default","",
			"Use this layout for any unknown content"},
		{AreaFacets.PANE_FLIP,"","","Reverse all panes"},
		{AreaFacets.PANE_RESET,"","","Restore last user defaults"},
		{KEY_TAB_CLOSE_LO,"Close tab"},//rem_co.gif
		{KEY_TAB_CLOSE_HI,"Close tab"},//remove.gif
		{KEY_DRAG_NOTIFY,"Retarget during drag"},
		{KEY_DRAG_WAIT,"Wait for pause"},
		{KEY_DRAG_PAUSE,"At least (millis)"},
		{DataConstants.TYPE_XML,"","generic_xml_obj.gif"},
		{DataConstants.ROOT_XML,"","generic_xml_obj.gif"},
		{DataConstants.TYPE_DATA,"","tree_mode.gif"},
		{DataConstants.TYPE_TEXT,"","mark_occurrences.gif"},
		{DataConstants.VALUE,"","write_obj.gif"},
		{DataConstants.VIEW_DATA,"","edtsrclkup_co.gif"},
		{ExceptionNode.TYPE,"","error_log.gif"},
		{KEY_SPLASH,"Sp&lash screen on startup","","[Not applicable in MDI]"},
		{KEY_DEBUG_STATUS,"Debug info in status bar"},
		{ActionAppSurface.KEY_TIMEOUTS+"|"+FacetPreferences.TITLE_FEATURES,
			"Timeout checking","","Warn if long operations time out"},
		{ActionAppSurface.KEY_TIMED_OUT,"Session Timed Out","",
			"The previous session of " +TAG_APP_TITLE+" appears to have timed out.<br>" +
			"Time out checking will be switched on. "},
		{ActionAppSurface.KEY_TIMEOUTS,"Timeout Checks","",
			"Timeout checking is switched on which may affect program performance.<br>" +
			"Continue running " +TAG_APP_TITLE+" with timeout checking?" +(true?"":
					" (You can change<br>this setting in Help>Debug.) ")},
		{FacetPreferences.TITLE_DRAG,"Drag"},
		{FacetPreferences.TITLE_FEATURES,"Features"},
		{FacetPreferences.TITLE_TIMES,"Times"},
		{FacetPreferences.TITLE_TRACE,"Trace"},
		{FacetPreferences.TITLE_VALUES,"Values"},
		{FacetPreferences.TITLE_VIEW,"View"},
		{FacetPreferences.TITLE_GRAPH,"Graph"},
		{FacetPreferences.TITLE_HEADER,"Debug"},
		{Events.KEY_EVENTS,"Construction and &retargeting"},
		{Events.KEY_BUILD,"&Build events and times"},
		{Events.KEY_FILTERS,"Include detail:"},
		{Events.KEY_TIMES,"Elapsed times (as instrumented)"},
		{Events.KEY_MEM,"Memory checks"},
		{Events.KEY_TIMES_RESET,"Wait before reset (ms)"},
		{Events.KEY_TRACE,"Show &trace in console"},
		{AppValues.PATH_DEBUG,"Debugging"},
		{TreeView.KEY_DEBUG,"Render trees with debug info"},
		{HtmlView.FONT_OFFSET,"Font size","","Reference size for rich text"},
		{HtmlView.KEY_SOURCE,"Show &HTML source in rich text viewers"},
		{TITLE_NO_FILE,"","","No valid file found or supplied - "+TAG_APP_TITLE +" will create default content"},
		{TITLE_NO_NEW,"","","No valid file found or supplied - "+TAG_APP_TITLE +" will close"},
		{TITLE_FILE_OPEN_PREVIOUS,"","","Re-open  "},
		{NATURE_CONFIRM_STATE_SAVE,"Save state?","","Save session state before close?"},
		{TITLE_NEW,"","","Create new application content",VK_N+KEY_CTRL},
		{TITLE_APP_CLOSE,"","terminate.gif","Exit program"},
		{TITLE_APP_HELP,"","help.gif",""},
		{TITLE_FILE_OPEN,"","folder_open.gif","",VK_O+KEY_CTRL},
		{TITLE_FILE_CLOSE,"","","",VK_W+KEY_CTRL},
		{TITLE_FILE_SAVE,"","save.gif","",VK_S+KEY_CTRL},
		{TITLE_FILE_REVERT,"","refresh_nav.gif"},
		{TreeTargets.TITLE_FIND,"","","",VK_F+KEY_CTRL},
		{TreeTargets.TITLE_FIND_NEXT,"","","",VK_F+KEY_CTRL+KEY_SHIFT},
		{TreeTargets.TITLE_SEARCH_TYPE,"Type","","= XML tag name"},
		{TreeTargets.TITLE_SEARCH_TITLE,"Title","","= primary attribute where defined"},
		{TreeTargets.TITLE_SEARCH_KEY,"Key","","= XML attribute name"},
		{TreeTargets.TITLE_SEARCH_VALUE,"Value","","= XML attribute value or content line"},
		{TreeTargets.TITLE_SEARCH_RESULTS,"Results","",""},
		{Action.REDO,"","redo_edit.gif"},
		{Action.UNDO,"","undo_edit.gif"},
		{Action.COPY,"","copy_edit.gif","Copy selection",VK_C+KEY_CTRL},
		{Action.CUT,"","cut_edit.gif","Cut selection",VK_X+KEY_CTRL},
		{Action.DELETE,"","delete_edit.gif","Delete selection",VK_DELETE},
		{HtmlView.PAGE_BACK,"","backward_nav.gif","Back"},//linkBack.gif
		{HtmlView.PAGE_FORWARD,"","forward_nav.gif","Forward"},//linkForward.gif
		{HtmlView.PAGE_PREVIOUS,"","back.gif","Previous page"},// pageUp.gif
		{HtmlView.PAGE_NEXT,"","forward.gif","Next page"},//pageDown.gif
		{HtmlView.FONT_SMALLER,"","reduce_font.gif","Decrease text size"},//fontSmaller.gif zoomout.gif
		{HtmlView.FONT_LARGER,"","magnify_font.gif","Increase text size"},//zoomin.gif fontLarger.gif
		{Action.ITERATE_BACK,"","back.gif","",VK_TAB+KEY_SHIFT},
		{Action.ITERATE_FORWARD,"","forward.gif","",VK_TAB},
		{Action.SELECT_ALL,"","","",VK_A+KEY_CTRL},
		{Action.PASTE,"","paste_edit.gif","Paste at selection",VK_V+KEY_CTRL},
		{Action.PASTE_INTO,"","addtsk_tsk.gif","Paste into selection",VK_V+KEY_SHIFT+KEY_CTRL},
		// history_obj.gif stepinto_co.gif
		{Action.EDIT,"","text_edit.gif","Modify or rename selection",VK_F2},
		//write_obj.gif
	};
}
/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

