package facets.facet.app;
import facets.core.app.ActionAppSurface;
import facets.core.app.DialogSurface;
import facets.core.app.SimpleContenter;
import facets.core.superficial.SFacet;
import facets.core.superficial.app.SAreaTarget;
import facets.core.superficial.app.SContentRootTargeter;
import facets.facet.FacetFactory;
import facets.util.Debug;
import facets.util.datatree.ValueNode;
/**
{@link SimpleContenter} that creates content for a  dialog in a 
{@link FacetAppSurface}. 
 */
public abstract class FacetDialogContenter extends SimpleContenter{
	/**
	{@link FacetFactory} for use by {@link FacetDialogContenter}.
	 */
	public static abstract class PanelFacets extends FacetFactory{
		public PanelFacets(FacetFactory core){
			super(core);
		}
		/**
		Build panel for {@link FacetDialogContenter}. 
		@param t passed from {@link FacetDialogContenter#newContentPanel(SContentRootTargeter)}
		 */
		public abstract SFacet newContentPanel(SContentRootTargeter t);
	}
	protected final FacetFactory ff;
	public FacetDialogContenter(String title,FacetFactory ff){
		super(title);
		this.ff=ff;
	}
	protected void attachRootMountFacet(SAreaTarget rootArea){
		ff.areas().mount(rootArea,FacetFactory.HINT_NONE);				
	}
	public SFacet newContentPanel(SContentRootTargeter t){
		return newPanelFacets(ff).newContentPanel(t);
	}
	/**
	Create a {@link PanelFacets} for return by {@link #newContentPanel(SContentRootTargeter)}. 
	@param core passed to factory constructor
	 */
	protected PanelFacets newPanelFacets(FacetFactory core){
		throw new RuntimeException("Not implemented in "+Debug.info(this));
	}
	@Override
	public void setDialog(DialogSurface dialog){}
}
/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

