package facets.facet.app.tree;
import static facets.facet.app.tree.TreeTargets.*;
import static facets.util.Strings.*;
import static facets.util.datatree.Nodes.*;
import facets.core.app.DialogActionDefaults;
import facets.core.app.DialogHost;
import facets.core.app.DialogSurface;
import facets.core.app.DialogSurface.Contenter;
import facets.core.app.DialogSurface.DialogActions;
import facets.core.app.Dialogs.Surfacer;
import facets.core.app.NodePath;
import facets.core.app.NodeViewable;
import facets.core.app.PathSelection;
import facets.core.superficial.Notice;
import facets.core.superficial.Notifying.Impact;
import facets.core.superficial.SFacet;
import facets.core.superficial.SIndexing;
import facets.core.superficial.SIndexing.Coupler;
import facets.core.superficial.STarget;
import facets.core.superficial.app.SContentRootTargeter;
import facets.core.superficial.app.SSurface;
import facets.facet.FacetFactory;
import facets.facet.app.FacetAppSurface;
import facets.facet.app.FacetDialogContenter;
import facets.facet.app.FacetDialogSurface;
import facets.facet.app.FacetDialogContenter.PanelFacets;
import facets.util.IndexingIterator;
import facets.util.OffsetPath;
import facets.util.Strings;
import facets.util.datatree.DataNode;
import facets.util.datatree.TypedNode;
import facets.util.datatree.ValueNode;
import java.awt.Dimension;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
final class TreeSearch extends FacetDialogContenter{
	private static final int MAX_CHARS=50;
	private final FacetAppSurface app;
	private final NodeViewable viewable;
	private final TypedNode tree;
	private final TypedNode selection;
	private final List<OffsetPath>searchStore,searchCopy=new ArrayList(),
		resultStore=new ArrayList();
	private final SIndexing types,titles,keys,values,results=new SIndexing(TITLE_SEARCH_RESULTS,
			new Coupler(){
		@Override
		public Object[]getIndexables(){
			resultStore.clear();
			for(final TypedNode node:descendants(tree)){
				if((types.index()!=0&&!node.type().equals(types.indexed()))
					||(titles.index()!=0&&!node.title().equals(titles.indexed())))continue;
				if(keys.index()==0&&values.index()==0){
					addResultPath(node,-1);
					continue;
				}
				new IndexingIterator<String>(((DataNode)node).values()){
					@Override
					protected void itemIterated(String value,int at){
						if(isKeyPair(value)){
							String[]pair=splitPair(value);
							if(keys.index()!=0&&keys.indexed().equals(pair[0]))
								addResultPath(node,at);
							else if(keys.index()==0&&values.index()!=0&&values.indexed().equals(pair[1]))
								addResultPath(node,at);
						}
						else if(values.index()!=0&&values.indexed().equals(value))
							addResultPath(node,at);
					}
				}.iterateWithIndex();
			};
			StringBuilder indexables=new StringBuilder();
			for(OffsetPath result:resultStore){
				for(TypedNode node:ancestry((TypedNode)result.target(tree))) 
					indexables.append((node.parent()==null?"":">")+
							node.type()+":"+node.title());
				indexables.append("\n");
			}
			return indexables.toString().split("\n");
		}
		void addResultPath(TypedNode node,int valueAt){
			resultStore.add(new NodePath(ancestry(node)).valueAtChecked(valueAt));
		}
		@Override
		public void indexSet(SIndexing i){
			if(resultStore.size()==0)return;
			viewable.defineSelection(PathSelection.newSingle(
					viewable.framed,resultStore.get(i.index())));
			app.notify(new Notice(i,Impact.SELECTION));
		}
	});
	TreeSearch(FacetAppSurface app,NodeViewable viewable,List<OffsetPath>searchStore){
		super(TreeSearch.class.getSimpleName()+": "+viewable.title(),app.ff);
		this.app=app;
		this.searchStore=searchStore;
		searchCopy.addAll(searchStore);
		selection=(ValueNode)(this.viewable=viewable).selection().selection();
		tree=(TypedNode)viewable.framed;
		Set<String>types=new HashSet(),titles=new HashSet(),keys=new HashSet(),
			values=new HashSet();
		for(TypedNode each:descendants(tree)){
			types.add(trimToLength(each.type(),MAX_CHARS));
			titles.add(trimToLength(each.title(),MAX_CHARS));
			for(String value:((DataNode)each).values()){
				if(isKeyPair(value)){
					String[]pair=splitPair(value);
					keys.add(trimToLength(pair[0],MAX_CHARS));
					if(pair.length>1)values.add(trimToLength(pair[1],MAX_CHARS));
				}
				else values.add(trimToLength(value,MAX_CHARS));
			}
		}
		Coupler coupler=new Coupler(){
			@Override
			public void indexSet(SIndexing i){
				results.setIndex(0);
			}
		};
		this.types=TreeSearch.newFieldIndexing(types,coupler,TITLE_SEARCH_TYPE);
		this.titles=TreeSearch.newFieldIndexing(titles,coupler,TITLE_SEARCH_TITLE);
		this.keys=TreeSearch.newFieldIndexing(keys,coupler,TITLE_SEARCH_KEY);
		this.values=TreeSearch.newFieldIndexing(values,coupler,TITLE_SEARCH_VALUE);
	}
	@Override
	protected STarget[]lazyContentRootElements(){
		return new STarget[]{types,titles,keys,values,results};
	}
	@Override
	public void applyChanges(){
		viewable.defineSelection(PathSelection.newSingle(
				viewable.framed,resultStore.get(results.index())));
		searchStore.clear();
		searchStore.addAll(resultStore);
	}
	@Override
	public void reverseChanges(){
		searchStore.clear();
		searchStore.addAll(searchCopy);
	}
	@Override
	public SFacet newContentPanel(SContentRootTargeter t){
		return newPanelFacets(ff).newContentPanel(t);
	}
	@Override
	protected PanelFacets newPanelFacets(FacetFactory core){
		return new PanelFacets(core){
			@Override
			public SFacet newContentPanel(SContentRootTargeter t){
				return rowPanel(t,0,5,HINT_PANEL_INSET,
					rowPanel(t,0,5,HINT_GRID,
						indexingDropdownList(t.elements()[0],HINT_NONE),BREAK,
						indexingDropdownList(t.elements()[1],HINT_NONE),BREAK,
						fill()
					),
					spacerWide(20),
					rowPanel(t,0,5,HINT_GRID,
						indexingDropdownList(t.elements()[2],HINT_NONE),BREAK,
						indexingDropdownList(t.elements()[3],HINT_NONE),BREAK,
						fill()
					),
					BREAK,
					indexingPaneSingle(t.elements()[4],-0,1,HINT_SPREAD)
				);
			}
		};
	}
	@Override
	public Dimension contentAreaSize(){
		return new Dimension(350,200);
	}
	private static SIndexing newFieldIndexing(Set<String>set,SIndexing.Coupler coupler,
			String fieldName){
		ArrayList sorter=new ArrayList(set);
		Collections.sort(sorter);
		sorter.add(0,"[Any "+fieldName.replace(TS,"")+"]");
		return new SIndexing(fieldName,sorter.toArray(),0,coupler);
	}
	static void launchDialog(TreeSearch search){
		search.app.dialogs().launchSurfaced(new Surfacer(){
			@Override
			protected DialogSurface newSurface(SSurface app,DialogHost host,String title,
					DialogActions actions,Contenter[]contents){
				return new FacetDialogSurface((FacetAppSurface)app,host,title,
						actions,contents){
					public boolean isResizable(){
						return true;
					}
				};
			}
		},TITLE_SEARCH_FIND,DialogActionDefaults.newOkCancel(),search);
	}
}/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
