package facets.facet.toolkit;
import static facets.facet.FacetFactory.*;
import facets.core.app.AppConstants;
import facets.facet.FacetFactory;
import facets.util.Debug;
import facets.util.StringFlags;
import facets.util.Tracer;
import facets.util.Util;
import java.util.Collection;
import java.util.Map;
final public class Decoration extends Tracer{
	final public StringFlags hints;
  final public Object icon,disable,keyStroke;
	final public String keyText,caption,mnemonicCaption,rubric;
	final public int mnemonic;
	public String[]titleSplits;
	Decoration(String keyText,Kit kit,StringFlags hints){
	  if((this.keyText=keyText)==null||keyText.equals(""))
	  	throw new IllegalArgumentException("Null or empty keyText in "+Debug.info(this));
	  else if(kit==null)throw new IllegalArgumentException("Null kit in "+Debug.info(this));
	  else if((this.hints=hints)==null||keyText.equals(""))
	  	throw new IllegalArgumentException("Null or empty hints in "+Debug.info(this));
	  boolean debug=hints.includeFlag(HINT_DEBUG)||keyText.equals("");
		icon=kit.getDecorationIcon(keyText,false);
		disable=kit.getDecorationIcon(keyText,true);
		keyStroke=kit.getDecorationKeyStroke(keyText);
		String useText=keyText;
		titleSplits=useText.split("\\|");
		if(titleSplits.length>1)useText=
				titleSplits[hints.includeFlag(HINT_TITLE3)?2:hints.includeFlag(HINT_TITLE2)?1:0];
		useText=kit.getDecorationTitle(useText);
		if(debug)trace(": useText="+useText);
	  int mnemonicAt=useText.indexOf('&')+1;
	  mnemonic=true||useText.length()>1?useText.toUpperCase().charAt(mnemonicAt):0;
		String captionTop=useText.substring(0,mnemonicAt-(mnemonicAt==0?0:1)),
			captionTail=useText.substring(mnemonicAt);
		caption=captionTop+captionTail;
		mnemonicCaption=captionTop+"&"+captionTail;
		String rubric=kit.rubrics.get(keyText);
		this.rubric=rubric==null?"":rubric;
		if(debug)trace(":",this);
	}
	public String toString(){
		return Debug.info(this)+" keyText="+keyText+" caption="+caption
		+"\n mnemonic="+mnemonic+" mnemonicCaption="+mnemonicCaption+" rubric="+rubric
		+"\n hints="+hints;
	}
	public String tabCaption(){
	  int spaceAt=caption.indexOf(' ');
	  String forTab=true&&spaceAt<0?caption:caption.substring(0,spaceAt);
	  int chars=caption.length();
	  return forTab=chars<20?forTab:
	  	forTab.substring(0,8)+"..."+forTab.substring(chars-8);
	}
}
/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

