package facets.facet.toolkit;
import facets.core.app.AppSurface;
import facets.core.app.DialogHost;
import facets.core.app.DialogSurface;
import facets.core.superficial.SFacet;
import facets.core.superficial.app.SHost;
import facets.core.superficial.app.SViewer;
import facets.facet.app.FacetDialogSurface;
import facets.util.Debug;
import facets.util.Tracer;
import java.awt.Rectangle;
public abstract class DialogHostCore extends Tracer implements DialogHost{
	private final class Layout implements FacetLayout{
		final KitFacet content,buttons,extras;
		Layout(SFacet content,SFacet buttons,SFacet extras){
			this.content=(KitFacet)content;
			this.buttons=(KitFacet)buttons;
			this.extras=(KitFacet)extras;
		}
	}
	protected final SHost host;
	protected final Kit kit;
	protected Object wrapped;
	private Layout layout;
	protected DialogHostCore(SHost host,Kit kit){
		this.host=host;
		this.kit=kit;
	}
	public final FacetLayout newWindowLayout(SFacet content,SFacet buttons,SFacet extras){
		return new Layout(content,buttons,extras);
	}
	public final void setLayout(FacetLayout layout){
		this.layout=(Layout)layout;		
	}
	public final void launchWindowedSurface(DialogSurface surface,AppSurface app){
		if(wrapped==null){
			Kit.widgets++;
			wrapped=newWrapped();
			setLayoutWidgets(layout.content,layout.buttons,layout.extras);
		}
		updateLayout(app);
		double factor=kit.layoutFactor();
		FacetDialogSurface faceted=(FacetDialogSurface)surface;
		launchInWindow(faceted.scaledLaunchBounds(factor),faceted.isResizable());
	  faceted.hostWindowDismissed(getClosingBounds(),factor);
	}
	protected abstract Object newWrapped();
	protected abstract void setLayoutWidgets(KitFacet content,KitFacet buttons, 
			KitFacet extras);
	protected abstract void launchInWindow(Rectangle bounds,boolean resizable);
	protected abstract Rectangle getClosingBounds();
	public final Object wrapped(){
		return wrapped;
	}
}/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
