package facets.facet.toolkit;
import facets.core.superficial.Notifiable;
import facets.core.superficial.SFacet;
import facets.core.superficial.STarget;
import facets.util.Titled;
/*
A {@link Facet} that can create, monitor and update widgets exposing
its target to view and control in the surface. 
 */
public interface KitFacet extends SFacet,Titled{
  /*
Convenience method for <code>items()[0]</code> in the usual case
where only a single widget need be returned. 
   */
  KWrap base();
  /*
Return all widgets needed to represent the facet. 
<p>Used directly only for a block of menu items controlled by a single facet.</p> 
   */
  KWrap[]items();
	void targetNotify(Object msg, boolean interim);
}
/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

