package facets.facet.toolkit.swing;
import static facets.facet.FacetFactory.*;
import facets.core.superficial.FacetedTarget;
import facets.core.superficial.SFacet;
import facets.facet.toolkit.Decoration;
import facets.facet.toolkit.KWrap;
import facets.facet.toolkit.Kit;
import facets.facet.toolkit.KitFacet;
import facets.util.Debug;
import facets.util.IndexingIterator;
import facets.util.StringFlags;
import java.awt.Component;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.Icon;
import javax.swing.JComponent;
import javax.swing.JTabbedPane;
import javax.swing.SwingConstants;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
final class AreaTabs extends MountCore{
	AreaTabs(final Kit kit,final SFacet[]areas,final StringFlags hints){
		super(NO_FACET,null);
		setSwing(new JTabbedPane(SwingConstants.TOP){{
				KitSwing.adjustFont(this);
				new IndexingIterator<SFacet>(areas){
					protected void itemIterated(SFacet item,int at){
						KitFacet area=(KitFacet)item;
						Decoration decorations=kit.decoration(area.title(),hints);
						Kit.widgets++;
						addTab(decorations.caption,(Icon)decorations.icon,
								(JComponent)area.base().wrapped());
					}
				}.iterateWithIndex();
				addChangeListener(new ChangeListener(){
					public void stateChanged(ChangeEvent e){
						ensureAreaActive();
					}
				});			
				addMouseListener(new MouseAdapter(){
					@Override
					public void mouseClicked(MouseEvent e){
						ensureAreaActive();
					}
				});
			}
			private void ensureAreaActive(){
				int areaAt=getSelectedIndex();
				if(areaAt<0)return;
				FacetedTarget target=(FacetedTarget)areas[areaAt].target();
				if(false)trace(".ensureAreaActive: ",target.title());
				target.ensureActive(true);
			}
		});
	}
	public void setActiveItem(KWrap item){
	  ((JTabbedPane)swing).setSelectedComponent((Component)item.wrapped());
	}
	public void setItems(KWrap... items){
		throw new RuntimeException("Not implemented in "+Debug.info(this));
	}
}/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
