package facets.facet.toolkit.swing;
import facets.facet.FacetFactory;
import facets.facet.toolkit.Kit;
import facets.facet.toolkit.KitFacet;
import facets.util.Debug;
import facets.util.NumberPolicy;
import facets.util.StringFlags;

import java.text.DecimalFormat;
import java.text.NumberFormat;
final class FieldNumber extends FieldText{
	private final NumberFormat formatter;
	public FieldNumber(KitFacet facet,NumberPolicy policy,Kit toolkit,
			StringFlags hints){
	  super(facet,policy.columns(),true,toolkit,hints);
		int format=policy.format();
		if(format>=NumberPolicy.FORMAT_DECIMALS_0){
		  formatter=DecimalFormat.getInstance();
	    formatter.setMaximumFractionDigits(format);
			formatter.setMinimumFractionDigits(format);
			formatter.setGroupingUsed(!hints.includeFlag(FacetFactory.HINT_NUMERIC_UNGROUPED));
		}
		else if(format==NumberPolicy.FORMAT_HEX)formatter=null;
		else 
			{formatter=null;throw new RuntimeException("Format not implemented in "+Debug.info(this));}
	}
	public void setValue(double value){
	  String formatted=formatter!=null?formatter.format(value):
	    Integer.toHexString((int)value).toUpperCase();
    setText(formatted);
	}
	public double value(){
		if(formatter!=null)
		  try{return Double.valueOf(text()).doubleValue();}
		catch(NumberFormatException e){return Double.valueOf(lastSetText).doubleValue();}
		else 
		  try{return Integer.parseInt(text(),16);}
			catch(NumberFormatException e){return Integer.parseInt(lastSetText,16);}
	}
}
/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

