package facets.facet.toolkit.swing;
import facets.core.app.HtmlView;
import facets.util.Debug;
import facets.util.Util;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import javax.swing.JComponent;
import javax.swing.JEditorPane;
import javax.swing.JPanel;
import javax.swing.JViewport;
class HtmlWrapPane extends JPanel{
	private static final boolean trace=false;
	private JEditorPane editor;
	private Boolean wrapNow=false;
	HtmlWrapPane(JEditorPane editor){
		super(new BorderLayout());
		editor.setBorder(null);
		add(this.editor=editor);
	}
	final void refreshForWrap(boolean wrapNow){
		if(this.wrapNow==wrapNow)return;
		Container parentThen=editor.getParent();
		boolean wrapThen=parentThen instanceof JViewport;
		if(wrapThen!=this.wrapNow)throw new IllegalStateException(
				"Inconsistent wrap state in "+Debug.info(this));
		else this.wrapNow=wrapNow;
		if(trace)Util.println("HtmlWrapPane.adjustForWrap wrapThen="+wrapThen+
				" wrapNow="+wrapNow);
		if(wrapNow){
			removeAll();
			editor.setBorder(getBorder());
			((JViewport)getParent()).setView(editor);
		}
		else{
			editor.setBorder(null);
			add(editor);
			((JViewport)parentThen).setView(this);
		}
		findViewport().validate();
	}
	void refreshForEditor(JEditorPane editor){
		if(this.editor==editor)return;
		else if(editor==null)editor=new JEditorPane("text","No editor");
		if(trace)Util.println("HtmlWrapPane.refreshForEditor wrapNow="+wrapNow+
				" parent=",Debug.info(editor.getParent()));
		if(wrapNow){
			editor.setBorder(getBorder());
			((JViewport)this.editor.getParent()).setView(editor);
		}
		else{
			editor.setBorder(null);
			removeAll();
			add(editor);
		}
		this.editor=editor;
		findViewport().validate();
		editor.repaint();
	}
	final JViewport findViewport(){
		Container parent=getParent(),viewport=parent==null?editor.getParent():parent;
		if(viewport==null)throw new IllegalStateException(
				"Null viewport in "+Debug.info(this));
		return(JViewport)viewport;
	}
	final JEditorPane editor(){
		if(editor.getParent()==null)throw new IllegalStateException(
				"Not adjusted for editor="+Debug.info(editor)+" in "+Debug.info(this));
		else return editor;
	}
}/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
