package facets.facet.toolkit.swing;
import facets.util.Debug;
import facets.util.Util;

import java.applet.Applet;
class LiveConnectApplet extends Applet{
  static abstract class JSObject{    
    abstract Object eval(String string);
    abstract Object getMember(String string);
    abstract Object call(String string,Object object);
    static JSObject getWindow(Object applet){
			throw new RuntimeException("Not implemented");
		}
  }
  private JSObject win;private String received="No string received",name="Unnamed";
  protected void alert(String msg){if(win!=null)win.eval("alert('"+msg+"')");}
  protected Class appletClass(int applet){
    Class appletClass=null;
    String className=(String)call("getAppletClassName",applet);
    try{appletClass=Class.forName(className);}catch(Exception e){return null;}
    return appletClass;
  }
  protected JSObject applets(){return(JSObject)document().getMember("applets");}
  protected int appletsLength(){
    Object o=applets().getMember("length");
    if(o instanceof Double)return((Double)o).intValue();
    else return((Integer)o).intValue();
  }
  protected Object appletsMember(int index){return applets().getMember(index+"");}
  public void broadcastString(String msg){
    if(win==null){Util.println("[LiveConnect broadcast]");return;}
    try{
      for(int applet=0,appletsLength=appletsLength();applet<appletsLength;applet++){
        Object o=appletsMember(applet);if(!(o instanceof JSObject))continue;
        JSObject appletObject=(JSObject)o,
          classObject=(JSObject)appletObject.call("getClass",null);
        Class appletClass=Class.forName((String)classObject.call("getName",null));
        if(appletClass!=null&&LiveConnectApplet.class.isAssignableFrom(appletClass))
          appletObject.call("receiveString",new Object[]{msg});
      }
    }catch(Exception e){acquireConsole();Util.println("",e.getStackTrace());}
  }
  private void acquireConsole(){
		throw new IllegalArgumentException("Not implemented in "+Debug.info(this));		
	}
	protected Object call(String method,String[]args){
    return win.call(method,args);
  }
  protected Object call(String method,int arg)
    {return call(method,new String[]{Integer.toString(arg)});}
  protected Object call(String method,String arg)
    {return call(method,new String[]{arg});}
  protected void displayString(String msg)
    {acquireConsole();Util.println(name+": ",msg);}
  protected String eval(String eval){return(String)win.eval(eval);}
  public String getLastReceived(){return received;}
  public void init(){
  	super.init();
  	try{win=JSObject.getWindow(this);}catch(Throwable e){}
  }
  protected int messageRows(){return 5;}
  public void receiveString(String received)
    {this.received=received;if(messageRows()>0)displayString(received);}
  public void setName(String name)
    {this.name=name;acquireConsole();Util.println(name);}
  protected JSObject document(){return(JSObject)win.getMember("document");}
}
/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

