package facets.facet.toolkit.swing;
import facets.util.Debug;

import java.awt.event.ActionEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.AbstractAction;
import javax.swing.ActionMap;
import javax.swing.Icon;
import javax.swing.JRadioButton;
import javax.swing.SwingUtilities;
import javax.swing.plaf.ActionMapUIResource;
final class TristateRadioButton extends JRadioButton{
  public TristateRadioButton(){this("Tristate",null);}
  public TristateRadioButton(String text,Icon icon){
    super(text,icon);
    if(true)throw new IllegalStateException("Needs updating in "+Debug.info(this));
    setModel(new TristateButtonModel(false));
    super.addMouseListener(new MouseAdapter(){
      public void mousePressed(MouseEvent e){
				grabFocus();
				triModel().iterateState();
				TristateRadioButton.this.fireActionEvent();
			}
    });
    ActionMap actions=new ActionMapUIResource();
    actions.put("pressed",new AbstractAction(){
      public void actionPerformed(ActionEvent e){
				grabFocus();
				triModel().iterateState();
				TristateRadioButton.this.fireActionEvent();
			}
    });
    actions.put("released",null);
    SwingUtilities.replaceUIActionMap(this,actions);
  }
  public void addMouseListener(MouseListener l){}
  public void setIndeterminate(){
  	triModel().setIndeterminate();
	}
  public void setSelected(boolean on){
		triModel().setSelected(on);
	}
	protected void fireActionEvent(){
		fireActionPerformed(new ActionEvent(this,0,"Tristate"));
	}
	private TristateButtonModel triModel(){
		return (TristateButtonModel)getModel();
	}
}
/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

