package facets.facet.toolkit.swing;
import static facets.facet.FacetFactory.*;
import static facets.util.Times.*;
import static javax.swing.BorderFactory.*;
import static javax.swing.SwingUtilities.*;
import facets.core.app.AppSurface;
import facets.core.app.MenuFacets;
import facets.core.app.SurfaceServices;
import facets.core.superficial.Notifying.Impact;
import facets.core.superficial.SFacet;
import facets.core.superficial.STarget;
import facets.core.superficial.STrigger;
import facets.core.superficial.TargetCore;
import facets.core.superficial.app.ViewerTarget;
import facets.facet.FacetFactory;
import facets.facet.app.FacetAppSurface;
import facets.facet.toolkit.KViewer;
import facets.facet.toolkit.KWrap;
import facets.facet.toolkit.Kit;
import facets.facet.toolkit.KitFacet;
import facets.util.Debug;
import facets.util.ItemList;
import facets.util.StringFlags;
import facets.util.Tracer;
import facets.util.app.WatchableOperation;
import facets.util.app.ProvidingCache;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Cursor;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.AbstractAction;
import javax.swing.ActionMap;
import javax.swing.BorderFactory;
import javax.swing.Icon;
import javax.swing.InputMap;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.KeyStroke;
import javax.swing.ScrollPaneConstants;
import javax.swing.Timer;
import javax.swing.border.Border;
import javax.swing.border.CompoundBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
public final class ViewerBase extends Tracer implements KViewer,FocusListener{
	private static final boolean forceFocus=true,timing=false,focusTrace=false;
	private final static int focusWidth=1;
	final class FocusLabel extends JLabel{
	  final Border insetsBorder=createEmptyBorder(1,3,1,0);
		private final Color inactiveColor,activeColor;
		FocusLabel(Icon image){
			super(image,JLabel.LEFT);
		  KitSwing.adjustFont(this);
			inactiveColor=getBackground();
		  activeColor=inactiveColor.darker();
		  setBorder(insetsBorder);
		}
		void baseRefreshed(ViewerTarget target,JComponent swing){
	  	setVisible(swing==null||getAncestorOfClass(JTabbedPane.class,swing)==null);
			setText(kit.decoration(target.title(),hints).caption+
	  			(focusTrace?(" "+Debug.info(avatarPane)):""));
			boolean active=target.isActive();
  	  Color colour=active&&!hints.includeFlag(HINT_NO_FOCUS)?activeColor:inactiveColor;
			if(false)focusMount.setBackground(colour);
			focusMount.setBorder(createLineBorder(colour,focusWidth));
			if(false)setFont(getFont().deriveFont(active?Font.BOLD:0));
		}
	}
	public final KitSwing kit;
	public AppSurface app;
	final JScrollPane scroll;
	final KitFacet facet;
	final JComponent avatarPane;
	private final ViewerMaster master;
	private final JComponent focusMount;		
	private final FocusLabel liveLabel;
	private final MouseAdapter labelClickListener=new MouseAdapter(){
    public void mouseClicked(MouseEvent e){focusGained(null);}
  };
	private final JPopupMenu popup=new JPopupMenu();
	private KWrap[]popupThen;
	private boolean focusListening;
	final StringFlags hints;
	private JComponent swing;
	@Override
	protected void traceOutput(String msg){
		if(true)System.out.println(Debug.info(this)+msg);
	}
	@Override
	public String title(){
		return facet.title();
	}
	public ViewerBase(KitFacet facet,ViewerMaster master,KitSwing kit,StringFlags hints){
	  this.facet=facet;
	  this.kit=kit;
		this.hints=hints;
	  (this.master=master).base=this;
	  master.attachedToFacet();
	  if(false)printElapsed("ViewerBase.ViewerBase: "+facet);
	  avatarPane=master.newAvatarPane();
	  if(avatarPane==null)throw new IllegalStateException(
				"Null avatarPane in "+Debug.info(this));
	  if(false)printElapsed("ViewerBase.~ViewerBase: "+facet);
  	avatarPane.addMouseListener(new MouseAdapter(){
  		public void mouseClicked(MouseEvent e){
				focusGained(null);
			}
  		public void mousePressed(MouseEvent e){
				if(e.isPopupTrigger())popupRequested(e.getX(),e.getY());
				else super.mousePressed(e);
  		}
  	  public void mouseReleased(MouseEvent e){
				if(e.isPopupTrigger())popupRequested(e.getX(),e.getY());
			}
    });
  	int cursor=master.defaultCursor();
  	if(cursor>0)avatarPane.setCursor(Cursor.getPredefinedCursor(cursor));
		ViewerTarget target=(ViewerTarget)facet.target();
		if(target==null)throw new IllegalStateException(
				"No viewer target in "+Debug.info(this));
  	adjustAvatarPaneActions(target.actionTriggers);
  	scroll=!master.isScrollable()?null
  		:new JScrollPane(avatarPane,
  	    ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED,
  	    ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
  	if(scroll!=null)
  		scroll.getViewport().addChangeListener(new ChangeListener(){
  			private int thenAt=0;
				@Override
  			public void stateChanged(ChangeEvent e){
  				int at=scroll.getViewport().getViewPosition().y;
  				if(at==0)thenAt=at;
  				if(at==0||thenAt>0)return;
  				if(false)trace(".stateChanged: at="+at+" thenAt="+thenAt);
  				thenAt=at;
  				ViewerBase.this.focusGained(null);
  			}
  		});
  	if(hints.includeFlag(HINT_PANEL_BORDER))
  		avatarPane.setBorder(createCompoundBorder(
  			createLoweredBevelBorder(),
  			createLineBorder(Color.lightGray)
			));
    focusMount=hints.includeFlag(FacetFactory.HINT_BARE)?null
    		:new JPanel(new BorderLayout(0,0));
    if(focusMount!=null){		  
  	  if(FacetFactory.panelShade!=null)
  	    focusMount.setBackground(new Color(FacetFactory.panelShade.rgb()));
			focusMount.addMouseListener(labelClickListener);
  		focusMount.add(scroll!=null?scroll:avatarPane,BorderLayout.CENTER);
  		Object icon=kit.getDecorationIcon("", false);
  		liveLabel=new FocusLabel((Icon)icon);
  		focusMount.add(liveLabel,BorderLayout.SOUTH);
  		focusMount.addFocusListener(this);
    }
    else liveLabel=null;
		if(panelShade!=null)popup.setBackground(new Color(panelShade.rgb()));
    Kit.widgets+=4;
    new Timer(1500,new ActionListener(){
			public void actionPerformed(ActionEvent e){
				focusListening=true;
			}
		}){
    	public boolean isRepeats(){return false;}
    }.start();
  	if(focusTrace)avatarPane.addFocusListener(new FocusListener(){
			@Override
			public void focusLost(FocusEvent e){
				traceDebug(".avatarPane.focusLost:" +
						" isVisible=" +avatarPane.isVisible()+
						" >",e.getOppositeComponent());
			}
			@Override
			public void focusGained(final FocusEvent e){
				traceDebug(".avatarPane.focusGained:" +
						" isVisible=" +avatarPane.isVisible()+" ",e.getSource());
			}
		});
  }
	public void focusGained(FocusEvent e){
		if(!focusListening)return;
	  ViewerTarget target=(ViewerTarget)facet.target();
		if(target.isActive())return;
		if(focusTrace)trace(".focusGained: "+facet+" "+e);
		if(facet!=null)facet.targetNotify(this,false);
		if(forceFocus)invokeLater(new Runnable(){public void run(){
			if(focusTrace)trace(".~focusGained: ",avatarPane.isFocusOwner());
			avatarPane.requestFocusInWindow();
		}});
	}
	public void focusLost(FocusEvent e){
		if(focusTrace)trace(".focusLost: "+facet+" "+e);
	}
	public void refresh(final Impact impact){
	  final ViewerTarget target=(ViewerTarget)facet.target();
	  if(liveLabel!=null)liveLabel.baseRefreshed(target,swing);
		app=TargetCore.findMonitorOfType(AppSurface.class,target);
		if(target.isLive()){
	  	WatchableOperation refreshAvatars=new WatchableOperation(
	  			"ViewerBase.refresh.refreshAvatars"){
				public void doSimpleOperation(){
					if(timing)printElapsed(Debug.info(facet)+".refresh");
			  	master.refreshAvatars(impact);
			  	if(timing)printElapsed(Debug.info(facet)+".~refresh");
				}
			};
			if(app!=null&&false)app.runWatched(refreshAvatars);
			else refreshAvatars.doSimpleOperation();
	  }
	  boolean active=target.isActive();
	  if(!active)return;
		adjustAvatarPaneActions(target.actionTriggers);
		if(forceFocus&&!avatarPane.isFocusOwner())invokeLater(new Runnable(){public void run(){
			new Timer(0,new ActionListener(){
				public void actionPerformed(ActionEvent e){
					if(focusTrace)trace(".~refresh: ",avatarPane.isFocusOwner());
					avatarPane.requestFocusInWindow();
				}
			}){public boolean isRepeats(){return false;}}.start();
		}});
	}
	private void adjustAvatarPaneActions(STarget[]actionTargets){
		KeyStroke[]strokes=new KeyStroke[actionTargets.length];
		for(int i=0;i<strokes.length;i++)
			strokes[i]=(KeyStroke)kit.getDecorationKeyStroke(actionTargets[i].title());
		InputMap paneInputs=avatarPane.getInputMap(),inputs=paneInputs;
		for(;inputs!=null;inputs=inputs.getParent())
			for(int i=0;i<strokes.length;i++)inputs.put(strokes[i],actionTargets[i]);
		ActionMap paneActions=avatarPane.getActionMap(),actions=paneActions;
		for(;actions==paneActions;actions=actions.getParent())
			for(int i=0;i<strokes.length;i++){
				final STrigger trigger=(STrigger)actionTargets[i];
				actions.put(trigger,new AbstractAction(){
					@Override
					public void actionPerformed(ActionEvent e){
						trigger.fire();
						facet.targetNotify(this,false);
					}
				});
			}
	}
	public KitFacet facet(){
		return facet;
	}
	boolean isLabelMounted(){return focusMount!=null;}
	public Object wrapped(){
		if(swing!=null)return swing;
		swing=new JPanel(new BorderLayout()){
			@Override
			public void paint(Graphics g){
				if(timing)printElapsed(Debug.info(facet)+"..paint");
				super.paint(g);
				if(timing)printElapsed(Debug.info(facet)+"..~paint");
			}
		};
		swing.add(scroll==null?focusMount==null?avatarPane:focusMount
				:focusMount==null?scroll:scroll.getParent(),BorderLayout.CENTER);
		return swing;
	}
	void popupRequested(int atX,int atY){
		focusGained(null);
		if(app==null)return;
		ViewerTarget target=(ViewerTarget)facet.target();
		FacetFactory ff=true||app instanceof FacetAppSurface?
				((FacetAppSurface)app).ff:null;
		SFacet[]viewerFacets=master.getTargetFacets(ff);
		MenuFacets menuFacets=((SurfaceServices)app).getContextMenuFacets();
		SFacet[]facets=menuFacets==null?viewerFacets
				:menuFacets.getContextFacets(target,viewerFacets);
		if(facets==null)return;
		ItemList<KWrap>list=new ItemList(KWrap.class);
		for(int i=0;i<facets.length;i++)
			if(facets[i]!=null)list.addItems(((KitFacet)facets[i]).items());
		KWrap[]items=list.items();
		for(int i=0;popupThen!=null&&i<items.length;i++)
			if(items[i]!=popupThen[i])popupThen=null;
		popup.removeAll();
		for(int i=0;i<items.length;i++)
			if(items[i]==KWrap.BREAK)popup.addSeparator();
			else popup.add((JMenuItem)items[i].wrapped());
		popup.show(avatarPane,atX,atY);		
		popupThen=items;
	}
  public STarget[]targets(){
		return master.targets();
	}
	public Object newWrapped(Object parent){
    throw new RuntimeException("Not implemented in "+Debug.info(this));
  }
	public ProvidingCache providingCache(){
		return kit.providingCache();
	}
	public SurfaceServices services(){
		if(app==null)throw new IllegalStateException(
				"Null services in "+Debug.info(this));
		else return(SurfaceServices)app;
	}
}
/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

