package facets.facet.toolkit.swing.tree;
import facets.core.app.ListView;
import facets.core.app.NodePath;
import facets.core.app.PathSelection;
import facets.core.app.TreeView;
import facets.core.superficial.Notifying.Impact;
import facets.core.superficial.app.SViewer;
import facets.core.superficial.app.ViewerTarget;
import facets.util.Debug;
import facets.util.OffsetPath;
import facets.util.datatree.TypedNode;
import java.awt.Component;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import javax.swing.DefaultListCellRenderer;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
public class PathListPaneMaster extends PathNodePaneMaster{
  private Object[]itemsThen;
  public void refreshAvatars(Impact impact){
	  PathSelection selection=(PathSelection)viewerTarget().selection();
		OffsetPath path=selection.paths[0];
	  int index=pathSelectionIndex(path);
	  JList list=(JList)avatarPane();
	  if(index>-1)list.setSelectedIndex(index);
		SViewer viewer=viewerTarget();
		Object[]itemsNow=((TreeView)viewer.view()).nodeContents(
				viewer,(TypedNode)selection.content());
	  if(itemsNow==itemsThen)return;itemsThen=itemsNow;
		list.setListData(itemsNow); 
	}
	private int pathSelectionIndex(OffsetPath path){
		boolean debug=false;
		if(debug)trace("NodeViewer " +Debug.info(this)+": ",
				path.members(null));
		TypedNode root=(TypedNode)viewerTarget().selection().content();
		TypedNode[]children=root.children();
		Object indexed=path.target(root);
		if(debug)trace("pathSelectionIndex: ",indexed);
		if(children.length==0)return -1;
		for(int i=0;i<children.length;i++)if(children[i]==indexed)return i;
		return -1;
	}
  protected JComponent newAvatarPane(){
    final JList list=new JList();
    ListView view=((ListView)viewerTarget().view());
		if(view.isHorizontal()){
			list.setLayoutOrientation(JList.VERTICAL_WRAP);
			list.setVisibleRowCount(-1);
		}
    list.setCellRenderer(new DefaultListCellRenderer(){
      public Component getListCellRendererComponent(JList list,Object value,
          int at,boolean selected,boolean cellHasFocus){
        JLabel label=(JLabel)super.getListCellRendererComponent
        			(list,"",at,selected,cellHasFocus);
        PathListPaneMaster.this.modifyNodeValueRendering(value,label);
        return label;
      }
    });
		list.addListSelectionListener(new ListSelectionListener(){
			public void valueChanged(ListSelectionEvent e){
		  	ViewerTarget viewerTarget=PathListPaneMaster.this.viewerTarget();
		    PathSelection selection=(PathSelection)viewerTarget.selection();
				int listIndex=list.getSelectedIndex(),
					rootIndex=pathSelectionIndex(selection.paths[0]);
				if(list.getValueIsAdjusting()
						||rootIndex==listIndex
						||itemsThen==null||listIndex==-1)return;
				Object selected=itemsThen[listIndex];
				OffsetPath path=new NodePath(
						new Object[]{selection.content(),selected});
				viewerTarget.selectionChanged(
						PathSelection.newSingle(selection.content(),path));
			}
		});
		list.addKeyListener(new KeyAdapter(){
			public void keyReleased(KeyEvent e){
				char keyChar=e.getKeyChar();
				if(Character.isLetterOrDigit(keyChar))selectNextCharItem(list,keyChar);
			}
		});
    return list;
  }  
	protected void selectNextCharItem(JList list,char keyChar){
		String key=String.valueOf(keyChar);
	  int index=list.getSelectedIndex(),start=index>-1?index+1:0,
			found=-1;
	  if(false)trace("PathsListViewer: "+
	  		"key="+key+", index="+index+", start="+start);
	  for(int i=start;i<itemsThen.length&&found<0;i++){	  	
	  	String title=((TypedNode)itemsThen[i]).title();
			if(title.length()>0&&title.substring(0,1).equalsIgnoreCase(key))
				found=i;
			}
	  if(found<0)for(int i=0;i<start&&found==-1;i++){	  	
	  	String title=((TypedNode)itemsThen[i]).title();
			if(title.length()>0&&title.substring(0,1).equalsIgnoreCase(key))
				found=i;
			}
	  if(found>-1)list.setSelectedIndex(found);
	}
}
/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

