package facets.util;
import static java.lang.System.*;
/**
Simple timing for profiling and latency checks. 
 */
final public class Times{
	public static boolean times=false,nanoTime=false;
	public static long resetWait=1000;
  private static long then,start;
  private static long newMillis(){
		return(nanoTime?nanoTime()/1000/1000:currentTimeMillis());//&0x7ffff;
	}
  /**
	The time since the last auto-reset. 
	<p>Interval for reset set by {@link #resetWait}. 
	 */
  public static long elapsed(){
  	boolean first=then==0;
  	long now=newMillis();
  	if(first||now-then>resetWait)start=now;
		return(then=now)-start;
  }
  /**
	Print {@link #elapsed()} followed by the message. 
	 */
	public static void printElapsed(String msg){
    if(!times){
    	start=then=newMillis();
    	return;
    }
		long elapsed=elapsed();
    String elapsedText=true&&elapsed>5*1000?(Doubles.fixed(elapsed/1000d,1)+"")
    		:(""+elapsed), 
    	toPrint=(false&&elapsed==0?"\n":"")+elapsedText+(msg!=null?":\t"+msg:"");
		if(true)Util.println(toPrint);
		else Debug.memCheck(toPrint,false);
    if(msg==null)Debug.printStackTrace(10);
  }
}
/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

