package facets.util.datatree;
import static facets.util.datatree.DataConstants.*;
import static facets.util.datatree.TypedNode.*;
import facets.util.Tracer;
class TestTrees extends Tracer{
	private static int datas,numbers;
	private final static TypedNode 
	keyPairs=newNode("text=A simple text value",
			"keyedInts=1,2,3,4"
		),
	text=newNode("Some text on ",
			"two," ,
			"three or even " ,
			"four lines"),
	mixed=new ValueNode(TYPE_DATA,"Mixed",
			new Object[]{
			"First simple text value",
			newNode(),
			"Second simple text value",
			newNode(),
			"Last simple text value",
		});
	private static ValueNode newNode(Object...contents){
		return new ValueNode(TYPE_DATA,"Node"+numbers++,contents);
	}
	final DataNode tree;
	private final String rootType;
	private final int broad;
	private final double shrinkBy;
	TestTrees(String rootType,int broad,double shrinkBy){
		this.rootType=rootType;
		this.broad=broad+2;
		this.shrinkBy=shrinkBy;
		tree=new ValueNode(rootType,"Tree"+datas++);
		if(broad<1)tree.setContents(newDataNode("Dummy").contents());
		else addDescendants(tree,1.0,1);
		if(false)tree.setTitle(tree.title()+" nodes="+Nodes.descendants(tree).length);
	}
	private void addDescendants(DataNode parent,double shrunkBy,int level){
		int across=(int)(broad*shrunkBy);
		if(across<3){
			if(false)trace(": descendants="+Nodes.descendants(tree).length+" parent=",parent);
			return;
		}
		NodeList children=new NodeList(parent,true);
		for(int i=0;i<across;i++){
			ValueNode child=newDataNode("Level "+level);//+" Child "+i
			children.add(child);
			addDescendants(child,shrunkBy*shrinkBy,level+1);
		}
	}
	private ValueNode newDataNode(String title){
		return new ValueNode(TYPE_DATA,title,new Object[]{
			keyPairs.copyState(),
			text.copyState(),
			mixed.copyState(),
		});
	}
}/*/*
This file forms part of Version 0.8.79 of Facets, a framework demonstrating 
the Superficial approach to GUI-driven interactive applications.  
http://superficial.sourceforge.net 				
Copyright (C) 2011  David M Wright 
This library is free software; you can redistribute it and/or modify it under 
the terms of the GNU Lesser General Public License as published by the 
Free Software Foundation; either release 3 of the License, or (at your 
option) any later release.
This library is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR 
A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
details.
You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, Inc., 
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
